
/*  A Bison parser, made from parse.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	CLASS	258
#define	FROM	259
#define	CONST	260
#define	VOID	261
#define	STRUCT	262
#define	UNION	263
#define	ENUM	264
#define	THREEDOTS	265
#define	SIGNED	266
#define	UNSIGNED	267
#define	LONG	268
#define	SHORT	269
#define	INT	270
#define	FLOAT	271
#define	DOUBLE	272
#define	CHAR	273
#define	ONERROR	274
#define	TOKEN	275
#define	NUMBER	276
#define	TYPETOKEN	277
#define	CCODE	278
#define	HCODE	279
#define	PUBLIC	280
#define	PRIVATE	281
#define	ARGUMENT	282
#define	VIRTUAL	283
#define	SIGNAL	284
#define	OVERRIDE	285

#line 21 "parse.y"


#include "config.h"
#include <glib.h>
#include <stdio.h>
#include <string.h>

#include "tree.h"
#include "main.h"

#define _(x) (x)
	
extern char *filename;
	
GList *nodes = NULL;

static GList *class_nodes = NULL;
Node *class = NULL;

static GList *typestack = NULL;
static int stars = 0;
static GList *funcargs = NULL;
static GList *checks = NULL;
static int has_self = FALSE;
static int vararg = FALSE;

static GList *gtktypes = NULL;

void free(void *ptr);
int yylex(void);

extern int ccode_line;
extern int line_no;

extern char *yytext;

static void
yyerror(char *str)
{
	char *out=NULL;
	char *p;
	
	if(strcmp(yytext,"\n")==0) {
		out=g_strconcat("Error: ",str," before newline",NULL);
	} else if(yytext[0]=='\0') {
		out=g_strconcat("Error: ",str," at end of input",NULL);
	} else {
		char *tmp = g_strdup(yytext);
		while((p=strchr(tmp,'\n')))
			*p='.';

		out=g_strconcat("Error: ",str," before '",tmp,"'",NULL);
		g_free(tmp);
	}

	fprintf(stderr,"%s:%d: %s\n",filename,line_no,out);
	g_free(out);
	
	exit(1);
}

static void
push_variable(char *name, int scope, int line_no)
{
	Node *var;
	Type *type = typestack->data;
	typestack = g_list_remove(typestack,typestack->data);
	
	var = new_variable(scope,type,name,line_no);
	class_nodes = g_list_append(class_nodes, var);
}

static void
push_function(int scope, char *oid, char *id, char *onerror,
	      GString *cbuf,int line_no, int ccode_line, int vararg)
{
	Node *node;
	Type *type;
       
	if(scope!=INIT_METHOD && scope!=CLASS_INIT_METHOD) {
		type = typestack->data;
		typestack = g_list_remove(typestack,typestack->data);
	} else {
		type = (Type *)new_type(0,g_strdup("void"));
	}
	
	node = new_method(scope,type,oid,gtktypes,id,funcargs,
			  onerror,cbuf,line_no,ccode_line,vararg);
	gtktypes = NULL;
	funcargs = NULL;

	class_nodes = g_list_append(class_nodes, node);
}

static void
push_funcarg(char *name)
{
	Node *node;
	Type *type = typestack->data;
	typestack = g_list_remove(typestack,typestack->data);
	
	node = new_funcarg(type,name,checks);
	checks = NULL;
	
	funcargs = g_list_append(funcargs, node);
}

static void
push_init_arg(char *name, int is_class)
{
	Node *node;
	Node *type;
	char *tn;
	
	if(is_class)
		tn = g_strconcat(((Class *)class)->otype,":Class",NULL);
	else
		tn = g_strdup(((Class *)class)->otype);

	type = new_type(1,tn);
	node = new_funcarg((Type *)type,name,NULL);
	funcargs = g_list_prepend(funcargs, node);
}

static void
push_self(char *id)
{
	Node *node;
	Node *type;
	GList *ch = NULL;
	type = new_type(1,g_strdup(((Class *)class)->otype));
	ch = g_list_append(ch,new_check(NULL_CHECK,NULL));
	ch = g_list_append(ch,new_check(TYPE_CHECK,NULL));
	node = new_funcarg((Type *)type,id,ch);
	funcargs = g_list_prepend(funcargs, node);
}


#line 160 "parse.y"
typedef union {
	char *id;
	GString *cbuf;
	GList *list;
	int line;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		192
#define	YYFLAG		-32768
#define	YYNTBASE	45

#define YYTRANSLATE(x) ((unsigned)(x) <= 285 ? yytranslate[x] : 72)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    43,     2,     2,     2,     2,     2,     2,    34,
    35,    37,     2,    38,    44,     2,     2,     2,    40,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    33,    42,
    39,    41,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    31,    36,    32,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     7,    10,    12,    15,    18,    20,    22,    27,
    32,    35,    38,    41,    43,    45,    47,    52,    57,    69,
    78,    82,    83,    87,    89,    91,    94,    96,    99,   102,
   105,   107,   110,   113,   115,   117,   119,   121,   124,   126,
   128,   131,   133,   136,   138,   140,   142,   144,   146,   149,
   151,   156,   160,   162,   165,   167,   178,   188,   197,   210,
   220,   230,   236,   243,   246,   250,   253,   254,   256,   258,
   262,   264,   268,   270,   274,   276,   279,   286,   289,   291,
   293,   296,   299,   303,   307,   311,   315,   317,   320
};

static const short yyrhs[] = {    46,
    47,    46,     0,    47,    46,     0,    46,    47,     0,    47,
     0,    46,    23,     0,    46,    24,     0,    23,     0,    24,
     0,    48,    31,    49,    32,     0,     3,    22,     4,    22,
     0,    49,    63,     0,    49,    50,     0,    49,    51,     0,
    63,     0,    50,     0,    51,     0,    25,    54,    20,    33,
     0,    26,    54,    20,    33,     0,    27,    52,    20,    20,
    20,    31,    23,    20,    31,    23,    33,     0,    27,    52,
    20,    20,    20,    31,    23,    33,     0,    34,    53,    35,
     0,     0,    20,    36,    53,     0,    20,     0,    55,     0,
     5,    55,     0,    56,     0,    56,    59,     0,    12,    57,
     0,    11,    57,     0,    57,     0,    12,    18,     0,    11,
    18,     0,    18,     0,    17,     0,    16,     0,    20,     0,
    58,    20,     0,    22,     0,     6,     0,    13,    15,     0,
    13,     0,    14,    15,     0,    14,     0,    15,     0,     9,
     0,     8,     0,     7,     0,    37,    59,     0,    37,     0,
    20,    34,    61,    35,     0,    61,    38,    20,     0,    20,
     0,    31,    23,     0,    33,     0,    29,    20,    60,    54,
    20,    34,    65,    35,    64,    62,     0,    29,    60,    54,
    20,    34,    65,    35,    64,    62,     0,    28,    54,    20,
    34,    65,    35,    64,    62,     0,    30,    34,    22,    35,
    54,    20,    34,    65,    35,    64,    31,    23,     0,    25,
    54,    20,    34,    65,    35,    64,    31,    23,     0,    26,
    54,    20,    34,    65,    35,    64,    31,    23,     0,    20,
    34,    20,    35,    33,     0,    20,    34,    20,    35,    31,
    23,     0,    19,    71,     0,    19,    31,    23,     0,    39,
    40,     0,     0,     6,     0,    20,     0,    20,    38,    66,
     0,    66,     0,    67,    38,    10,     0,    67,     0,    67,
    38,    68,     0,    68,     0,    54,    20,     0,    54,    20,
    34,    20,    69,    35,     0,    69,    70,     0,    70,     0,
    20,     0,    41,    71,     0,    42,    71,     0,    41,    39,
    71,     0,    42,    39,    71,     0,    39,    39,    71,     0,
    43,    39,    71,     0,    21,     0,    44,    21,     0,    20,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   178,   179,   180,   181,   184,   188,   192,   196,   202,   209,
   214,   215,   216,   217,   218,   219,   222,   225,   229,   258,
   284,   285,   288,   291,   297,   298,   306,   310,   317,   320,
   323,   326,   329,   332,   335,   338,   341,   344,   348,   351,
   356,   359,   362,   365,   368,   373,   376,   379,   384,   385,
   388,   393,   396,   401,   402,   406,   428,   438,   448,   454,
   459,   464,   482,   503,   504,   508,   509,   512,   513,   528,
   543,   546,   547,   550,   551,   554,   557,   567,   568,   571,
   584,   588,   592,   596,   600,   604,   610,   611,   615
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","CLASS",
"FROM","CONST","VOID","STRUCT","UNION","ENUM","THREEDOTS","SIGNED","UNSIGNED",
"LONG","SHORT","INT","FLOAT","DOUBLE","CHAR","ONERROR","TOKEN","NUMBER","TYPETOKEN",
"CCODE","HCODE","PUBLIC","PRIVATE","ARGUMENT","VIRTUAL","SIGNAL","OVERRIDE",
"'{'","'}'","';'","'('","')'","'|'","'*'","','","'='","'1'","'>'","'<'","'!'",
"'-'","prog","ccodes","class","classdec","classcode","variable","argument","argflags",
"flaglist","type","type1","type2","integer","tspecifier","stars","sigtype","tokenlist",
"codenocode","method","onerror","funcargs","arglist","arglist1","arg","checklist",
"check","numtok", NULL
};
#endif

static const short yyr1[] = {     0,
    45,    45,    45,    45,    46,    46,    46,    46,    47,    48,
    49,    49,    49,    49,    49,    49,    50,    50,    51,    51,
    52,    52,    53,    53,    54,    54,    55,    55,    56,    56,
    56,    56,    56,    56,    56,    56,    56,    56,    56,    56,
    57,    57,    57,    57,    57,    58,    58,    58,    59,    59,
    60,    61,    61,    62,    62,    63,    63,    63,    63,    63,
    63,    63,    63,    64,    64,    64,    64,    65,    65,    65,
    65,    66,    66,    67,    67,    68,    68,    69,    69,    70,
    70,    70,    70,    70,    70,    70,    71,    71,    71
};

static const short yyr2[] = {     0,
     3,     2,     2,     1,     2,     2,     1,     1,     4,     4,
     2,     2,     2,     1,     1,     1,     4,     4,    11,     8,
     3,     0,     3,     1,     1,     2,     1,     2,     2,     2,
     1,     2,     2,     1,     1,     1,     1,     2,     1,     1,
     2,     1,     2,     1,     1,     1,     1,     1,     2,     1,
     4,     3,     1,     2,     1,    10,     9,     8,    12,     9,
     9,     5,     6,     2,     3,     2,     0,     1,     1,     3,
     1,     3,     1,     3,     1,     2,     6,     2,     1,     1,
     2,     2,     3,     3,     3,     3,     1,     2,     1
};

static const short yydefact[] = {     0,
     0,     7,     8,     0,     4,     0,     0,     5,     6,     3,
     2,     0,     0,     1,     0,     0,     0,    22,     0,     0,
     0,     0,    15,    16,    14,    10,     0,     0,    40,    48,
    47,    46,     0,     0,    42,    44,    45,    36,    35,    34,
    37,    39,     0,    25,    27,    31,     0,     0,     0,     0,
     0,     0,     0,     0,     9,    12,    13,    11,     0,    26,
    33,    30,    32,    29,    41,    43,     0,    50,    28,    38,
     0,    24,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    17,     0,    49,    18,     0,     0,    21,     0,     0,
    53,     0,     0,     0,     0,     0,    62,    40,    37,     0,
     0,    71,    73,    75,     0,    23,     0,     0,    51,     0,
     0,     0,     0,    63,     0,    76,    67,     0,    67,     0,
    67,    52,     0,     0,     0,    70,     0,     0,     0,     0,
    72,    74,     0,     0,     0,     0,    67,     0,     0,    89,
    87,     0,     0,    64,    66,     0,     0,     0,    20,     0,
    55,    58,    67,     0,     0,    80,     0,     0,     0,     0,
     0,    79,    65,    88,    60,    61,     0,    54,     0,    57,
    67,     0,     0,    81,     0,    82,     0,    77,    78,     0,
    56,     0,    85,    83,    84,    86,    19,     0,    59,     0,
     0,     0
};

static const short yydefgoto[] = {   190,
     4,     5,     6,    22,    23,    24,    50,    73,   100,    44,
    45,    46,    47,    69,    53,    92,   152,    25,   130,   101,
   102,   103,   104,   161,   162,   144
};

static const short yypact[] = {    32,
    81,-32768,-32768,    36,    53,   -15,   108,-32768,-32768,    53,
   137,   138,    92,   137,    87,    93,    93,    96,    93,     3,
    98,   127,-32768,-32768,-32768,-32768,   118,   128,-32768,-32768,
-32768,-32768,    60,   156,   134,   136,-32768,-32768,-32768,-32768,
-32768,-32768,   157,-32768,   125,-32768,   158,   159,   160,   161,
   162,    -2,    93,   163,-32768,-32768,-32768,-32768,   148,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    19,   125,-32768,-32768,
   139,   150,   149,   167,   154,   155,   170,    93,   171,   164,
    10,-32768,   111,-32768,-32768,   111,   160,-32768,   172,   111,
-32768,    23,   173,   166,    93,   174,-32768,   168,    28,   175,
   169,-32768,   176,-32768,   177,-32768,   165,   178,-32768,   181,
   182,   111,   185,-32768,    93,   183,   -11,    75,   -11,   179,
   -11,-32768,   111,   180,   184,-32768,   186,   -14,   187,   188,
-32768,-32768,   189,    -7,    63,   190,   -11,   111,    29,-32768,
-32768,   198,   201,-32768,-32768,   200,   203,   193,-32768,   205,
-32768,-32768,   -11,    63,   194,-32768,   191,   -10,    -6,   192,
     5,-32768,-32768,-32768,-32768,-32768,   209,-32768,    63,-32768,
   -11,     1,     1,-32768,     1,-32768,     1,-32768,-32768,   202,
-32768,   206,-32768,-32768,-32768,-32768,-32768,   210,-32768,   207,
   208,-32768
};

static const short yypgoto[] = {-32768,
    14,   230,-32768,-32768,   214,   216,-32768,   107,   -16,   211,
-32768,   142,-32768,   130,   195,-32768,  -142,   218,  -117,   -81,
    94,-32768,   123,-32768,    49,  -108
};


#define	YYLAST		247


static const short yytable[] = {    43,
    48,   133,    51,   135,   105,   140,   141,   128,   108,   140,
   141,   170,   148,   140,   141,    12,   142,    76,    11,   154,
   140,   141,    52,    14,   156,   149,   181,   129,   173,   143,
   124,    77,   175,   143,     1,   169,    79,   143,     1,   178,
    96,   136,    97,   157,   143,   158,   159,   160,   156,   174,
   176,    82,    83,   182,     2,     3,   155,   109,     8,     9,
   110,    93,   -69,   183,   184,   115,   185,   157,   186,   158,
   159,   160,    35,    36,    37,     2,     3,    61,   113,    28,
    29,    30,    31,    32,   131,    33,    34,    35,    36,    37,
    38,    39,    40,   150,    41,   151,    42,    28,    29,    30,
    31,    32,     7,    33,    34,    35,    36,    37,    38,    39,
    40,    13,    41,    26,    42,    28,    98,    30,    31,    32,
    27,    33,    34,    35,    36,    37,    38,    39,    40,    49,
    99,    54,    42,    29,    30,    31,    32,    59,    33,    34,
    35,    36,    37,    38,    39,    40,    15,    41,    65,    42,
    66,    16,    17,    18,    19,    20,    21,    15,    55,     8,
     9,    68,    16,    17,    18,    19,    20,    21,    35,    36,
    37,    85,    86,    63,    62,    64,    67,    70,    71,    72,
    74,    75,    81,    88,    80,    87,    89,    90,    77,    91,
    94,   107,   111,   106,   116,   120,   114,    84,    95,   112,
   122,   134,   -68,   117,   125,   139,   191,   192,   126,   179,
     0,   119,   121,   118,   137,   123,   127,   138,   146,   147,
   163,   164,   165,   167,   153,   166,   145,   168,   171,   172,
   177,   180,   189,    10,   187,    56,   188,    57,    60,    58,
   132,     0,     0,     0,     0,     0,    78
};

static const short yycheck[] = {    16,
    17,   119,    19,   121,    86,    20,    21,    19,    90,    20,
    21,   154,    20,    20,    21,    31,    31,    20,     5,   137,
    20,    21,    20,    10,    20,    33,   169,    39,    39,    44,
   112,    34,    39,    44,     3,   153,    53,    44,     3,    35,
    31,   123,    33,    39,    44,    41,    42,    43,    20,   158,
   159,    33,    34,   171,    23,    24,   138,    35,    23,    24,
    38,    78,    35,   172,   173,    38,   175,    39,   177,    41,
    42,    43,    13,    14,    15,    23,    24,    18,    95,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    31,    20,    33,    22,     5,     6,     7,
     8,     9,    22,    11,    12,    13,    14,    15,    16,    17,
    18,     4,    20,    22,    22,     5,     6,     7,     8,     9,
    34,    11,    12,    13,    14,    15,    16,    17,    18,    34,
    20,    34,    22,     6,     7,     8,     9,    20,    11,    12,
    13,    14,    15,    16,    17,    18,    20,    20,    15,    22,
    15,    25,    26,    27,    28,    29,    30,    20,    32,    23,
    24,    37,    25,    26,    27,    28,    29,    30,    13,    14,
    15,    33,    34,    18,    33,    34,    20,    20,    20,    20,
    20,    20,    35,    35,    22,    36,    20,    34,    34,    20,
    20,    20,    20,    87,    20,    31,    23,    68,    35,    34,
    20,    23,    35,    35,    20,    20,     0,     0,   115,   161,
    -1,    35,    35,    38,    35,    34,    34,    34,    31,    31,
    23,    21,    23,    31,    35,    23,    40,    23,    35,    39,
    39,    23,    23,     4,    33,    22,    31,    22,    28,    22,
   118,    -1,    -1,    -1,    -1,    -1,    52
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 178 "parse.y"
{ ; ;
    break;}
case 2:
#line 179 "parse.y"
{ ; ;
    break;}
case 3:
#line 180 "parse.y"
{ ; ;
    break;}
case 4:
#line 181 "parse.y"
{ ; ;
    break;}
case 5:
#line 184 "parse.y"
{
			Node *node = new_ccode(FALSE,yyvsp[0].cbuf,ccode_line);
			nodes = g_list_append(nodes,node);
					;
    break;}
case 6:
#line 188 "parse.y"
{
			Node *node = new_ccode(TRUE,yyvsp[0].cbuf,ccode_line);
			nodes = g_list_append(nodes,node);
					;
    break;}
case 7:
#line 192 "parse.y"
{
			Node *node = new_ccode(FALSE,yyvsp[0].cbuf,ccode_line);
			nodes = g_list_append(nodes,node);
					;
    break;}
case 8:
#line 196 "parse.y"
{
			Node *node = new_ccode(TRUE,yyvsp[0].cbuf,ccode_line);
			nodes = g_list_append(nodes,node);
					;
    break;}
case 9:
#line 202 "parse.y"
{
			((Class *)class)->nodes = class_nodes;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 10:
#line 209 "parse.y"
{
			class = new_class(yyvsp[-2].id,yyvsp[0].id,NULL);
						;
    break;}
case 11:
#line 214 "parse.y"
{ ; ;
    break;}
case 12:
#line 215 "parse.y"
{ ; ;
    break;}
case 13:
#line 216 "parse.y"
{ ; ;
    break;}
case 14:
#line 217 "parse.y"
{ ; ;
    break;}
case 15:
#line 218 "parse.y"
{ ; ;
    break;}
case 16:
#line 219 "parse.y"
{ ; ;
    break;}
case 17:
#line 222 "parse.y"
{
			push_variable(yyvsp[-1].id,PUBLIC_SCOPE,yyvsp[-3].line);
						;
    break;}
case 18:
#line 225 "parse.y"
{
			push_variable(yyvsp[-1].id,PRIVATE_SCOPE,yyvsp[-3].line);
						;
    break;}
case 19:
#line 229 "parse.y"
{
			if(strcmp(yyvsp[-6].id,"get")==0 &&
			   strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,yyvsp[-9].list,yyvsp[-7].id,
						    yyvsp[-4].cbuf,yyvsp[-5].line,
						    yyvsp[-1].cbuf,yyvsp[-2].line,
						    yyvsp[-10].line);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-6].id,"set")==0 &&
				strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,yyvsp[-9].list,yyvsp[-7].id,
						    yyvsp[-1].cbuf,yyvsp[-2].line,
						    yyvsp[-4].cbuf,yyvsp[-5].line,
						    yyvsp[-10].line);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-8].id); g_free(yyvsp[-7].id);
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				g_list_foreach(yyvsp[-9].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				g_string_free(yyvsp[-4].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 20:
#line 258 "parse.y"
{
			if(strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,yyvsp[-6].list,yyvsp[-4].id,
						    yyvsp[-1].cbuf,yyvsp[-2].line,NULL,0,
						    yyvsp[-7].line);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,yyvsp[-6].list,yyvsp[-4].id,
						    NULL,0,yyvsp[-1].cbuf,yyvsp[-2].line,
						    yyvsp[-7].line);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-3].id); g_free(yyvsp[-5].id);
				g_free(yyvsp[-4].id);
				g_list_foreach(yyvsp[-6].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 21:
#line 284 "parse.y"
{ yyval.list = yyvsp[-1].list; ;
    break;}
case 22:
#line 285 "parse.y"
{ yyval.list = NULL; ;
    break;}
case 23:
#line 288 "parse.y"
{
			yyval.list = g_list_append(yyvsp[0].list,yyvsp[-2].id);
						;
    break;}
case 24:
#line 291 "parse.y"
{
			yyval.list = g_list_append(NULL,yyvsp[0].id);
						;
    break;}
case 25:
#line 297 "parse.y"
{ ; ;
    break;}
case 26:
#line 298 "parse.y"
{
			Type *type = typestack->data;
			char *oldname = type->name;
			type->name = g_strconcat("const ",oldname,NULL);
			g_free(oldname);
						;
    break;}
case 27:
#line 306 "parse.y"
{
			Node *node = new_type(0,yyvsp[0].id);
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 28:
#line 310 "parse.y"
{
			Node *node = new_type(stars,yyvsp[-1].id);
			stars = 0;
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 29:
#line 317 "parse.y"
{
			yyval.id = g_strconcat("unsigned ",yyvsp[0].id,NULL);
						;
    break;}
case 30:
#line 320 "parse.y"
{
			yyval.id = g_strconcat("signed ",yyvsp[0].id,NULL);
						;
    break;}
case 31:
#line 323 "parse.y"
{
			yyval.id = g_strdup(yyvsp[0].id);
						;
    break;}
case 32:
#line 326 "parse.y"
{
			yyval.id = g_strdup("unsigned char");
						;
    break;}
case 33:
#line 329 "parse.y"
{
			yyval.id = g_strdup("signed char");
						;
    break;}
case 34:
#line 332 "parse.y"
{
			yyval.id = g_strdup("char");
						;
    break;}
case 35:
#line 335 "parse.y"
{
			yyval.id = g_strdup("double");
						;
    break;}
case 36:
#line 338 "parse.y"
{
			yyval.id = g_strdup("float");
						;
    break;}
case 37:
#line 341 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 38:
#line 344 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id,yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
						;
    break;}
case 39:
#line 348 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 40:
#line 351 "parse.y"
{
			yyval.id = g_strdup("void");
						;
    break;}
case 41:
#line 356 "parse.y"
{
			yyval.id = "long int";
						;
    break;}
case 42:
#line 359 "parse.y"
{
			yyval.id = "long";
						;
    break;}
case 43:
#line 362 "parse.y"
{
			yyval.id = "short int";
						;
    break;}
case 44:
#line 365 "parse.y"
{
			yyval.id = "short";
						;
    break;}
case 45:
#line 368 "parse.y"
{
			yyval.id = "int";
						;
    break;}
case 46:
#line 373 "parse.y"
{
			yyval.id = "enum ";
						;
    break;}
case 47:
#line 376 "parse.y"
{
			yyval.id = "union ";
						;
    break;}
case 48:
#line 379 "parse.y"
{
			yyval.id = "struct ";
						;
    break;}
case 49:
#line 384 "parse.y"
{ stars++; ;
    break;}
case 50:
#line 385 "parse.y"
{ stars++; ;
    break;}
case 51:
#line 388 "parse.y"
{
			gtktypes = g_list_prepend(gtktypes,yyvsp[-3].id);
						;
    break;}
case 52:
#line 393 "parse.y"
{
			gtktypes = g_list_append(gtktypes,yyvsp[0].id);
						;
    break;}
case 53:
#line 396 "parse.y"
{ 
			gtktypes = g_list_append(gtktypes,yyvsp[0].id);
       						;
    break;}
case 54:
#line 401 "parse.y"
{ yyval.cbuf=yyvsp[0].cbuf; ;
    break;}
case 55:
#line 402 "parse.y"
{ yyval.cbuf = NULL; ;
    break;}
case 56:
#line 406 "parse.y"
{
			int sigtype = SIGNAL_LAST_METHOD;
			if(strcmp(yyvsp[-8].id,"first")==0)
				sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-8].id,"last")==0)
				sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-8].id);
				YYERROR;
			}
			g_free(yyvsp[-8].id);

			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(sigtype,NULL,
				      yyvsp[-5].id, yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-9].line,
				      ccode_line,vararg);
									;
    break;}
case 57:
#line 428 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(SIGNAL_LAST_METHOD, NULL,
				      yyvsp[-5].id, yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-8].line,
				      ccode_line,vararg);
									;
    break;}
case 58:
#line 438 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-7].line,
				      ccode_line,vararg);
									;
    break;}
case 59:
#line 448 "parse.y"
{
			push_function(OVERRIDE_METHOD, yyvsp[-9].id,
				      yyvsp[-6].id, yyvsp[-2].id, yyvsp[0].cbuf,
				      yyvsp[-11].line,yyvsp[-1].line,
				      vararg);
									;
    break;}
case 60:
#line 454 "parse.y"
{
			push_function(PUBLIC_SCOPE, NULL, yyvsp[-6].id,
				      yyvsp[-2].id, yyvsp[0].cbuf,yyvsp[-8].line,yyvsp[-1].line,
				      vararg);
								;
    break;}
case 61:
#line 459 "parse.y"
{
			push_function(PRIVATE_SCOPE, NULL, yyvsp[-6].id,
				      yyvsp[-2].id, yyvsp[0].cbuf,yyvsp[-8].line,yyvsp[-1].line,
				      vararg);
								;
    break;}
case 62:
#line 464 "parse.y"
{
			if(strcmp(yyvsp[-4].id,"init")==0) {
				push_init_arg(yyvsp[-2].id,FALSE);
				push_function(INIT_METHOD, NULL, yyvsp[-4].id, 
					      NULL, NULL,yyvsp[-3].line,0,
					      FALSE);
			} else if(strcmp(yyvsp[-4].id,"class_init")==0) {
				push_init_arg(yyvsp[-2].id,TRUE);
				push_function(CLASS_INIT_METHOD, NULL,
					      yyvsp[-4].id, NULL, NULL,yyvsp[-3].line,0,
					      FALSE);
			} else {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 63:
#line 482 "parse.y"
{
			if(strcmp(yyvsp[-5].id,"init")==0) {
				push_init_arg(yyvsp[-3].id,FALSE);
				push_function(INIT_METHOD, NULL,
					      yyvsp[-5].id, NULL, yyvsp[0].cbuf,yyvsp[-4].line,
					      yyvsp[-1].line,FALSE);
			} else if(strcmp(yyvsp[-5].id,"class_init")==0) {
				push_init_arg(yyvsp[-3].id,TRUE);
				push_function(CLASS_INIT_METHOD, NULL, 
					      yyvsp[-5].id, NULL, yyvsp[0].cbuf,yyvsp[-4].line,
					      yyvsp[-1].line,FALSE);
			} else {
				g_free(yyvsp[-5].id);
				g_free(yyvsp[-3].id);
				g_string_free(yyvsp[-3].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 64:
#line 503 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 65:
#line 504 "parse.y"
{
			yyval.id = (yyvsp[0].cbuf)->str;
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 66:
#line 508 "parse.y"
{ ; ;
    break;}
case 67:
#line 509 "parse.y"
{ yyval.id = NULL; ;
    break;}
case 68:
#line 512 "parse.y"
{ has_self = FALSE; ;
    break;}
case 69:
#line 513 "parse.y"
{
			has_self = TRUE;
			if(strcmp(yyvsp[0].id,"this")==0) {
				push_self(yyvsp[0].id);
				print_error(TRUE,_("Use of 'this' is "
						   "depreciated, use 'self' "
						   "instead"),line_no);
			} else if(strcmp(yyvsp[0].id,"self")==0)
				push_self(yyvsp[0].id);
			else {
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
       					;
    break;}
case 70:
#line 528 "parse.y"
{
			has_self = TRUE;
			if(strcmp(yyvsp[-2].id,"this")==0) {
				push_self(yyvsp[-2].id);
				print_error(TRUE,_("Use of 'this' is "
						   "depreciated, use 'self' "
						   "instead"),line_no);
			} else if(strcmp(yyvsp[-2].id,"self")==0)
				push_self(yyvsp[-2].id);
			else {
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 71:
#line 543 "parse.y"
{ has_self = FALSE; ;
    break;}
case 72:
#line 546 "parse.y"
{ vararg = TRUE; ;
    break;}
case 73:
#line 547 "parse.y"
{ vararg = FALSE; ;
    break;}
case 74:
#line 550 "parse.y"
{ ; ;
    break;}
case 75:
#line 551 "parse.y"
{ ; ;
    break;}
case 76:
#line 554 "parse.y"
{
			push_funcarg(yyvsp[0].id);
								;
    break;}
case 77:
#line 557 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-4].id);
								;
    break;}
case 78:
#line 567 "parse.y"
{ ; ;
    break;}
case 79:
#line 568 "parse.y"
{ ; ;
    break;}
case 80:
#line 571 "parse.y"
{
			if(strcmp(yyvsp[0].id,"type")==0) {
				Node *node = new_check(TYPE_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else if(strcmp(yyvsp[0].id,"null")==0) {
				Node *node = new_check(NULL_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[0].id);
					;
    break;}
case 81:
#line 584 "parse.y"
{
			Node *node = new_check(GT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 82:
#line 588 "parse.y"
{
			Node *node = new_check(LT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 83:
#line 592 "parse.y"
{
			Node *node = new_check(GE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 84:
#line 596 "parse.y"
{
			Node *node = new_check(LE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 85:
#line 600 "parse.y"
{
			Node *node = new_check(EQ_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 86:
#line 604 "parse.y"
{
			Node *node = new_check(NE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 87:
#line 610 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 88:
#line 611 "parse.y"
{
			yyval.id = g_strconcat("-",yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
					;
    break;}
case 89:
#line 615 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 618 "parse.y"

